diff --git a/src/main/java/net/minecraft/core/block/FullRotatableBlock.java b/src/main/java/net/minecraft/core/block/FullRotatableBlock.java
index 4488c5f3e..26a9682a5 100644
--- a/src/main/java/net/minecraft/core/block/FullRotatableBlock.java
+++ b/src/main/java/net/minecraft/core/block/FullRotatableBlock.java
@@ -2,10 +2,10 @@ package net.minecraft.core.block;
 
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.entity.Mob;
-import net.minecraft.core.enums.PlacementMode;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
+import org.jetbrains.annotations.NotNull;
 
 public abstract class FullRotatableBlock extends Block {
     public FullRotatableBlock(String translationKey, String namespaceId, int id, Material material) {
@@ -13,7 +13,7 @@ public abstract class FullRotatableBlock extends Block {
     }
 
     @Override
-    public void onBlockPlacedByMob(World world, int x, int y, int z, Side side, Mob mob, double sideHeight) {
+    public void onBlockPlacedByMob(World world, int x, int y, int z, @NotNull Side side, Mob mob, double sideHeight) {
         final Direction direction = mob.getPlacementDirection(side).getOpposite();
 
         world.setBlockMetadataWithNotify(x, y, z, directionToMeta(direction));
diff --git a/src/main/java/net/minecraft/core/block/JukeboxBlock.java b/src/main/java/net/minecraft/core/block/JukeboxBlock.java
index 096fbdb3f..7dac2e605 100644
--- a/src/main/java/net/minecraft/core/block/JukeboxBlock.java
+++ b/src/main/java/net/minecraft/core/block/JukeboxBlock.java
@@ -4,11 +4,13 @@ package net.minecraft.core.block;
 //            BlockContainer, Material, World, JukeboxBlockEntity,
 //            ItemEntity, ItemStack, Player, BlockEntity
 
+import net.minecraft.core.block.entity.ActivatorBlockEntity;
 import net.minecraft.core.block.entity.BlockEntity;
 import net.minecraft.core.block.entity.JukeboxBlockEntity;
 import net.minecraft.core.entity.ItemEntity;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 import net.minecraft.core.block.material.Material;
@@ -34,13 +36,20 @@ public class JukeboxBlock extends EntityBlock
         }
     }
 
-    public void playRecord(World world, int i, int j, int k, int l)
+    @Override
+    public void onActivatorInteract(World world, int x, int y, int z, ActivatorBlockEntity activator, Direction direction) {
+        if (world.getBlockMetadata(x, y, z) != 0) {
+            ejectRecord(world, x, y, z);
+        }
+    }
+
+    public void playRecord(World world, int x, int y, int z, int recordId)
     {
         if (!world.isClientSide) {
-            JukeboxBlockEntity tileentityrecordplayer = (JukeboxBlockEntity) world.getBlockEntity(i, j, k);
-            tileentityrecordplayer.record = l;
-            tileentityrecordplayer.setChanged();
-            world.setBlockMetadataWithNotify(i, j, k, 1);
+            JukeboxBlockEntity jukebox = (JukeboxBlockEntity) world.getBlockEntity(x, y, z);
+            jukebox.record = recordId;
+            jukebox.setChanged();
+            world.setBlockMetadataWithNotify(x, y, z, 1);
         }
     }
 
diff --git a/src/main/java/net/minecraft/core/block/LampBlock.java b/src/main/java/net/minecraft/core/block/LampBlock.java
index bd5d968fe..f185e66fc 100644
--- a/src/main/java/net/minecraft/core/block/LampBlock.java
+++ b/src/main/java/net/minecraft/core/block/LampBlock.java
@@ -8,6 +8,7 @@ import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.DyeColor;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
+import org.jetbrains.annotations.NotNull;
 
 public class LampBlock extends Block implements IPainted {
     public boolean isActive;
@@ -18,7 +19,7 @@ public class LampBlock extends Block implements IPainted {
     }
 
     @Override
-    public void onBlockPlacedByMob(World world, int x, int y, int z, Side side, Mob mob, double sideHeight) {
+    public void onBlockPlacedByMob(World world, int x, int y, int z, @NotNull Side side, Mob mob, double sideHeight) {
         if (world.isClientSide) {
             return;
         }
diff --git a/src/main/java/net/minecraft/core/block/LeverBlock.java b/src/main/java/net/minecraft/core/block/LeverBlock.java
index 7cc1b88b0..81440557e 100644
--- a/src/main/java/net/minecraft/core/block/LeverBlock.java
+++ b/src/main/java/net/minecraft/core/block/LeverBlock.java
@@ -1,5 +1,6 @@
 package net.minecraft.core.block;
 
+import net.minecraft.core.block.entity.ActivatorBlockEntity;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.entity.Mob;
 import net.minecraft.core.entity.player.Player;
@@ -8,10 +9,13 @@ import net.minecraft.core.item.Item;
 import net.minecraft.core.item.tag.ItemTags;
 import net.minecraft.core.sound.SoundCategory;
 import net.minecraft.core.util.helper.Axis;
+import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.World;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 
 public class LeverBlock extends Block
 {
@@ -68,7 +72,7 @@ public class LeverBlock extends Block
     }
     
     @Override
-    public void onBlockPlacedByMob(World world, int x, int y, int z, Side side, Mob mob, double sideHeight) {
+    public void onBlockPlacedByMob(World world, int x, int y, int z, @NotNull Side side, Mob mob, double sideHeight) {
         int meta = world.getBlockMetadata(x, y, z);
         boolean isPowered = isPowered(meta);
         int rotation = -1;
@@ -199,6 +203,11 @@ public class LeverBlock extends Block
     @Override
     public boolean onBlockRightClicked(World world, int x, int y, int z, Player player, Side side, double xPlaced, double yPlaced)
     {
+        flip(world, x, y, z, player);
+        return true;
+    }
+
+    public void flip(World world, int x, int y, int z, @Nullable Player player) {
         int meta = world.getBlockMetadata(x, y, z);
         int rotation = getRotation(meta);
         if (isPowered(meta)){
@@ -223,7 +232,11 @@ public class LeverBlock extends Block
         } else {
             world.notifyBlocksOfNeighborChange(x, y + 1, z, id);
         }
-        return true;
+    }
+
+    @Override
+    public void onActivatorInteract(World world, int x, int y, int z, ActivatorBlockEntity activator, Direction direction) {
+        flip(world, x, y, z, null);
     }
 
     @Override
diff --git a/src/main/java/net/minecraft/core/block/MobSpawnerBlock.java b/src/main/java/net/minecraft/core/block/MobSpawnerBlock.java
index b322e98ce..ede40f130 100644
--- a/src/main/java/net/minecraft/core/block/MobSpawnerBlock.java
+++ b/src/main/java/net/minecraft/core/block/MobSpawnerBlock.java
@@ -13,6 +13,7 @@ import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.player.gamemode.Gamemode;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
+import org.jetbrains.annotations.NotNull;
 
 public class MobSpawnerBlock extends EntityBlock
 {
@@ -39,7 +40,7 @@ public class MobSpawnerBlock extends EntityBlock
     }
 
     @Override
-	public void onBlockPlacedByMob(World world, int x, int y, int z, Side side, Mob mob, double sideHeight) {
+	public void onBlockPlacedByMob(World world, int x, int y, int z, @NotNull Side side, Mob mob, double sideHeight) {
     	MobSpawnerBlockEntity tileEntity = (MobSpawnerBlockEntity) world.getBlockEntity(x, y, z);
     	tileEntity.setMobId("none");
     }
diff --git a/src/main/java/net/minecraft/core/block/MossBlock.java b/src/main/java/net/minecraft/core/block/MossBlock.java
index ecdf73702..3ba84e837 100644
--- a/src/main/java/net/minecraft/core/block/MossBlock.java
+++ b/src/main/java/net/minecraft/core/block/MossBlock.java
@@ -6,6 +6,7 @@ import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 import net.minecraft.core.block.material.Material;
+import org.jetbrains.annotations.Nullable;
 
 import java.util.HashMap;
 import java.util.Map;
@@ -110,10 +111,10 @@ public class MossBlock extends Block implements IBonemealable {
 	}
 
 	@Override
-	public boolean onBonemealUsed(ItemStack itemstack, Player entityplayer, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced) {
+	public boolean onBonemealUsed(ItemStack itemstack, @Nullable Player player, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced) {
 		if(!world.isClientSide)
 		{
-			if (entityplayer.getGamemode().consumeBlocks())
+			if (player == null || player.getGamemode().consumeBlocks())
 			{
 				itemstack.stackSize--;
 			}
diff --git a/src/main/java/net/minecraft/core/block/MotionSensorBlock.java b/src/main/java/net/minecraft/core/block/MotionSensorBlock.java
index f2f3c668b..a1a0153e4 100644
--- a/src/main/java/net/minecraft/core/block/MotionSensorBlock.java
+++ b/src/main/java/net/minecraft/core/block/MotionSensorBlock.java
@@ -19,7 +19,7 @@ import net.minecraft.core.world.WorldSource;
 //            Block, Material, World, Item,
 //            Player, Entity
 
-public class MotionSensorBlock extends RotatableEntityBlock
+public class MotionSensorBlock extends VeryRotatableEntityBlock
 {
     public final boolean isActive;
 
@@ -29,13 +29,6 @@ public class MotionSensorBlock extends RotatableEntityBlock
         this.isActive = isActive;
     }
 
-    @Override
-	public void onBlockPlacedByWorld(World world, int x, int y, int z)
-    {
-        super.onBlockPlacedByWorld(world, x, y, z);
-        setDefaultDirection(world, x, y, z);
-    }
-
     @Override
 	public void animationTick(World world, int x, int y, int z, Random rand)
     {
@@ -116,6 +109,8 @@ public class MotionSensorBlock extends RotatableEntityBlock
     }
     
     public static Direction getFacingDirection(int meta) {
+    	if(meta == 0) return Direction.DOWN;
+    	if(meta == 1) return Direction.UP;
     	if(meta == 2) return Direction.NORTH;
     	if(meta == 3) return Direction.SOUTH;
     	if(meta == 4) return Direction.WEST;
diff --git a/src/main/java/net/minecraft/core/block/NoteBlock.java b/src/main/java/net/minecraft/core/block/NoteBlock.java
index e82d6bd7f..90811c569 100644
--- a/src/main/java/net/minecraft/core/block/NoteBlock.java
+++ b/src/main/java/net/minecraft/core/block/NoteBlock.java
@@ -1,9 +1,11 @@
 package net.minecraft.core.block;
 
+import net.minecraft.core.block.entity.ActivatorBlockEntity;
 import net.minecraft.core.block.entity.BlockEntity;
 import net.minecraft.core.block.entity.NoteBlockEntity;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.sound.SoundCategory;
+import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 import net.minecraft.core.block.material.Material;
@@ -49,6 +51,13 @@ public class NoteBlock extends EntityBlock
         }
     }
 
+    @Override
+    public void onActivatorInteract(World world, int x, int y, int z, ActivatorBlockEntity activator, Direction direction) {
+        NoteBlockEntity noteBlock = (NoteBlockEntity)world.getBlockEntity(x, y, z);
+        noteBlock.changePitch();
+        noteBlock.triggerNote(world, x, y, z);
+    }
+
     @Override
     public void onBlockLeftClicked(World world, int x, int y, int z, Player player, Side side, double xHit, double yHit)
     {
diff --git a/src/main/java/net/minecraft/core/block/PaintedFenceBlock.java b/src/main/java/net/minecraft/core/block/PaintedFenceBlock.java
index 0e78e1721..006bb02d8 100644
--- a/src/main/java/net/minecraft/core/block/PaintedFenceBlock.java
+++ b/src/main/java/net/minecraft/core/block/PaintedFenceBlock.java
@@ -7,6 +7,7 @@ import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.DyeColor;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
+import org.jetbrains.annotations.Nullable;
 
 public class PaintedFenceBlock extends FenceBlock implements IPainted
 {
@@ -16,7 +17,7 @@ public class PaintedFenceBlock extends FenceBlock implements IPainted
 	}
 	
 	@Override
-	public int getPlacedBlockMetadata(Player player, ItemStack stack, World world, int x, int y, int z, Side side, double xPlaced, double yPlaced) {
+	public int getPlacedBlockMetadata(@Nullable Player player, ItemStack stack, World world, int x, int y, int z, Side side, double xPlaced, double yPlaced) {
 		return stack.getMetadata();
 	}
 
diff --git a/src/main/java/net/minecraft/core/block/PaintedFenceGateBlock.java b/src/main/java/net/minecraft/core/block/PaintedFenceGateBlock.java
index 88e93a734..2734b05ff 100644
--- a/src/main/java/net/minecraft/core/block/PaintedFenceGateBlock.java
+++ b/src/main/java/net/minecraft/core/block/PaintedFenceGateBlock.java
@@ -7,6 +7,7 @@ import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.DyeColor;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
+import org.jetbrains.annotations.Nullable;
 
 public class PaintedFenceGateBlock extends FenceGateBlock implements IPainted
 {
@@ -16,7 +17,7 @@ public class PaintedFenceGateBlock extends FenceGateBlock implements IPainted
 	}
 	
 	@Override
-	public int getPlacedBlockMetadata(Player player, ItemStack stack, World world, int x, int y, int z, Side side, double xPlaced, double yPlaced) {
+	public int getPlacedBlockMetadata(@Nullable Player player, ItemStack stack, World world, int x, int y, int z, Side side, double xPlaced, double yPlaced) {
 		return stack.getMetadata();
 	}
 
diff --git a/src/main/java/net/minecraft/core/block/PaintedPlanksBlock.java b/src/main/java/net/minecraft/core/block/PaintedPlanksBlock.java
index 2b7fa7b0b..dbb593e77 100644
--- a/src/main/java/net/minecraft/core/block/PaintedPlanksBlock.java
+++ b/src/main/java/net/minecraft/core/block/PaintedPlanksBlock.java
@@ -8,6 +8,7 @@ import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.DyeColor;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
+import org.jetbrains.annotations.Nullable;
 
 public class PaintedPlanksBlock extends Block implements IPainted
 {
@@ -17,7 +18,7 @@ public class PaintedPlanksBlock extends Block implements IPainted
     }
     
     @Override
-    public int getPlacedBlockMetadata(Player player, ItemStack stack, World world, int x, int y, int z, Side side, double xPlaced, double yPlaced)
+    public int getPlacedBlockMetadata(@Nullable Player player, ItemStack stack, World world, int x, int y, int z, Side side, double xPlaced, double yPlaced)
     {
     	return stack.getMetadata();
     }
diff --git a/src/main/java/net/minecraft/core/block/PaintedSlabBlock.java b/src/main/java/net/minecraft/core/block/PaintedSlabBlock.java
index 5afa1a745..a9508082c 100644
--- a/src/main/java/net/minecraft/core/block/PaintedSlabBlock.java
+++ b/src/main/java/net/minecraft/core/block/PaintedSlabBlock.java
@@ -7,6 +7,8 @@ import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.DyeColor;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 
 public class PaintedSlabBlock extends SlabBlock implements IPainted
 {
@@ -16,12 +18,12 @@ public class PaintedSlabBlock extends SlabBlock implements IPainted
 	}
 	
 	@Override
-	public int getPlacedBlockMetadata(Player player, ItemStack stack, World world, int x, int y, int z, Side side, double xPlaced, double yPlaced) {
+	public int getPlacedBlockMetadata(@Nullable Player player, ItemStack stack, World world, int x, int y, int z, Side side, double xPlaced, double yPlaced) {
 		return stack.getMetadata();
 	}
 
 	@Override
-	public void onBlockPlacedByMob(World world, int x, int y, int z, Side side, Mob mob, double sideHeight) {
+	public void onBlockPlacedByMob(World world, int x, int y, int z, @NotNull Side side, Mob mob, double sideHeight) {
 		int meta = mob.getVerticalPlacementDirection(side, sideHeight) == Direction.UP ? 2 : 0;
 		world.setBlockMetadataWithNotify(x, y, z, meta | (world.getBlockMetadata(x, y, z) & 0xF0));
 	}
diff --git a/src/main/java/net/minecraft/core/block/PaintedTrapDoorBlock.java b/src/main/java/net/minecraft/core/block/PaintedTrapDoorBlock.java
index a98faf1e2..df6618ca8 100644
--- a/src/main/java/net/minecraft/core/block/PaintedTrapDoorBlock.java
+++ b/src/main/java/net/minecraft/core/block/PaintedTrapDoorBlock.java
@@ -8,6 +8,7 @@ import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.DyeColor;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
+import org.jetbrains.annotations.Nullable;
 
 public class PaintedTrapDoorBlock extends TrapDoorBlock implements IPainted {
     public PaintedTrapDoorBlock(String key, String namespaceId, int id, Material material) {
@@ -15,7 +16,7 @@ public class PaintedTrapDoorBlock extends TrapDoorBlock implements IPainted {
     }
     
     @Override
-    public int getPlacedBlockMetadata(Player player, ItemStack stack, World world, int x, int y, int z, Side side, double xPlaced, double yPlaced) {
+    public int getPlacedBlockMetadata(@Nullable Player player, ItemStack stack, World world, int x, int y, int z, Side side, double xPlaced, double yPlaced) {
     	return stack.getMetadata() | super.getPlacedBlockMetadata(player, stack, world, x, y, z, side, xPlaced, yPlaced);
     }
     
diff --git a/src/main/java/net/minecraft/core/block/PressurePlateBlock.java b/src/main/java/net/minecraft/core/block/PressurePlateBlock.java
index 7e3565584..0c02f172d 100644
--- a/src/main/java/net/minecraft/core/block/PressurePlateBlock.java
+++ b/src/main/java/net/minecraft/core/block/PressurePlateBlock.java
@@ -9,6 +9,7 @@ import net.minecraft.core.sound.SoundCategory;
 import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.World;
 import net.minecraft.core.util.phys.AABB;
+import org.jetbrains.annotations.NotNull;
 
 import java.util.List;
 import java.util.Random;
@@ -195,7 +196,7 @@ public class PressurePlateBlock extends Block
         return 1;
     }
     @Override
-    public void onBlockPlacedByMob(World world, int x, int y, int z, Side side, Mob mob, double sideHeight) {
+    public void onBlockPlacedByMob(World world, int x, int y, int z, @NotNull Side side, Mob mob, double sideHeight) {
         if (!world.canPlaceOnSurfaceOfBlock(x, y - 1 , z) || (side.isHorizontal() && sideHeight > 0.5 && world.isBlockNormalCube(x, y + 1, z))){
             world.setBlockMetadata(x, y, z, world.getBlockMetadata(x, y, z) | 0b10);
         }
diff --git a/src/main/java/net/minecraft/core/block/RepeaterBlock.java b/src/main/java/net/minecraft/core/block/RepeaterBlock.java
index 9e8f2227d..cd036866e 100644
--- a/src/main/java/net/minecraft/core/block/RepeaterBlock.java
+++ b/src/main/java/net/minecraft/core/block/RepeaterBlock.java
@@ -1,6 +1,7 @@
 package net.minecraft.core.block;
 
 import net.minecraft.client.util.helper.Colors;
+import net.minecraft.core.block.entity.ActivatorBlockEntity;
 import net.minecraft.core.block.entity.BlockEntity;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.entity.Mob;
@@ -9,13 +10,26 @@ import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.item.Items;
 import net.minecraft.core.util.helper.Color;
+import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 
 import java.util.Random;
 public class RepeaterBlock extends Block
 {
+    public static final double[] torchPosOffset = {
+        -0.0625D, 0.0625D, 0.1875D, 0.3125D
+    };
+    private static final int[] tickDelayMap = {
+        1, 2, 3, 4
+    };
+    public static final int MASK_DIRECTION = 0b0000_0011;
+    public static final int MASK_TICK_DELAY = 0b0000_1100;
+
+    public final boolean isRepeaterPowered;
 
 	public RepeaterBlock(String key, String namespaceId, int id, boolean flag)
     {
@@ -63,13 +77,13 @@ public class RepeaterBlock extends Block
     @Override
 	public void updateTick(World world, int x, int y, int z, Random rand) {
         int meta = world.getBlockMetadata(x, y, z);
-        boolean flag = func_22022_g(world, x, y, z, meta);
+        boolean flag = isGettingPower(world, x, y, z, meta);
         if(isRepeaterPowered && !flag) {
             world.setBlockAndMetadataWithNotify(x, y, z, Blocks.REPEATER_IDLE.id, meta);
         } else if(!isRepeaterPowered) {
             world.setBlockAndMetadataWithNotify(x, y, z, Blocks.REPEATER_ACTIVE.id, meta);
             if(!flag) {
-                int i1 = (meta & 0xc) >> 2;
+                int i1 = (meta & MASK_TICK_DELAY) >> 2;
                 world.scheduleBlockUpdate(x, y, z, Blocks.REPEATER_ACTIVE.id, tickDelayMap[i1] * 2);
             }
         }
@@ -85,7 +99,7 @@ public class RepeaterBlock extends Block
         if(!isRepeaterPowered) {
             return false;
         }
-        int meta = worldSource.getBlockMetadata(x, y, z) & 3;
+        int meta = worldSource.getBlockMetadata(x, y, z) & MASK_DIRECTION;
         if(meta == 0 && side == Side.SOUTH) {
             return true;
         }
@@ -106,18 +120,18 @@ public class RepeaterBlock extends Block
             return;
         }
         int meta = world.getBlockMetadata(x, y, z);
-        boolean flag = func_22022_g(world, x, y, z, meta);
-        int j1 = (meta & 0xc) >> 2;
+        boolean flag = isGettingPower(world, x, y, z, meta);
+        int tickDelay = (meta & MASK_TICK_DELAY) >> 2;
         if(isRepeaterPowered && !flag) {
-            world.scheduleBlockUpdate(x, y, z, id, tickDelayMap[j1] * 2);
+            world.scheduleBlockUpdate(x, y, z, id, tickDelayMap[tickDelay] * 2);
         } else if(!isRepeaterPowered && flag) {
-            world.scheduleBlockUpdate(x, y, z, id, tickDelayMap[j1] * 2);
+            world.scheduleBlockUpdate(x, y, z, id, tickDelayMap[tickDelay] * 2);
         }
     }
 
-    private boolean func_22022_g(World world, int x, int y, int z, int meta)
+    private boolean isGettingPower(World world, int x, int y, int z, int meta)
     {
-        int direction = meta & 3;
+        int direction = meta & MASK_DIRECTION;
         switch(direction)
         {
         case 0: // '\0'
@@ -136,20 +150,25 @@ public class RepeaterBlock extends Block
     }
 
     @Override
-    public boolean onBlockRightClicked(World world, int x, int y, int z, Player player, Side side, double xHit, double yHit)
+    public boolean onBlockRightClicked(World world, int x, int y, int z, @Nullable Player player, Side side, double xHit, double yHit)
     {
-        int l = world.getBlockMetadata(x, y, z);
-        int i1 = (l & 0xc) >> 2;
-        i1 = i1 + 1 << 2 & 0xc;
-        world.setBlockMetadataWithNotify(x, y, z, i1 | l & 3);
+        int metadata = world.getBlockMetadata(x, y, z);
+        int tickDelay = (metadata & MASK_TICK_DELAY) >> 2;
+        tickDelay = ((tickDelay + 1) << 2) & MASK_TICK_DELAY;
+        world.setBlockMetadataWithNotify(x, y, z, tickDelay | metadata & MASK_DIRECTION);
         return true;
     }
 
     @Override
-    public void onBlockPlacedByMob(World world, int x, int y, int z, Side side, Mob mob, double sideHeight) {
+    public void onActivatorInteract(World world, int x, int y, int z, ActivatorBlockEntity activator, Direction direction) {
+        onBlockRightClicked(world, x, y, z, null, Side.NONE, 0.5, 0.5);
+    }
+
+    @Override
+    public void onBlockPlacedByMob(World world, int x, int y, int z, @NotNull Side side, Mob mob, double sideHeight) {
 		int l = mob.getHorizontalPlacementDirection(side).index;
 		world.setBlockMetadataWithNotify(x, y, z, l);
-		boolean flag = func_22022_g(world, x, y, z, l);
+		boolean flag = isGettingPower(world, x, y, z, l);
 		if(flag)
 		{
 		    world.scheduleBlockUpdate(x, y, z, id, 1);
@@ -196,7 +215,7 @@ public class RepeaterBlock extends Block
 		float blue = color.getBlue() / 255.0f;
 		
 		if (rand.nextInt(2) == 0) {
-			switch (meta & 3) {
+			switch (meta & MASK_DIRECTION) {
 			case 0:
 				zOffset = -0.3125D;
 				break;
@@ -211,31 +230,23 @@ public class RepeaterBlock extends Block
 				break;
 			}
 		} else {
-			int i1 = (meta & 0xc) >> 2;
-			switch (meta & 3) {
+			int tickDelay = (meta & MASK_TICK_DELAY) >> 2;
+			switch (meta & MASK_DIRECTION) {
 			case 0:
-				zOffset = torchPosOffset[i1];
+				zOffset = torchPosOffset[tickDelay];
 				break;
 			case 2:
-				zOffset = -torchPosOffset[i1];
+				zOffset = -torchPosOffset[tickDelay];
 				break;
 			case 3:
-				xOffset = torchPosOffset[i1];
+				xOffset = torchPosOffset[tickDelay];
 				break;
 			case 1:
-				xOffset = -torchPosOffset[i1];
+				xOffset = -torchPosOffset[tickDelay];
 				break;
 			}
 		}
 		world.spawnParticle("reddust", px + xOffset, py, pz + zOffset, red, green, blue, redstoneBrightness);
 	}
 
-    public static final double[] torchPosOffset = {
-        -0.0625D, 0.0625D, 0.1875D, 0.3125D
-    };
-    private static final int[] tickDelayMap = {
-        1, 2, 3, 4
-    };
-    public final boolean isRepeaterPowered;
-
 }
diff --git a/src/main/java/net/minecraft/core/block/RotatableBlock.java b/src/main/java/net/minecraft/core/block/RotatableBlock.java
index c48a984e8..6c6972c9e 100644
--- a/src/main/java/net/minecraft/core/block/RotatableBlock.java
+++ b/src/main/java/net/minecraft/core/block/RotatableBlock.java
@@ -2,10 +2,13 @@ package net.minecraft.core.block;
 
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.entity.Mob;
+import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
+import org.jetbrains.annotations.NotNull;
 
 public abstract class RotatableBlock extends Block{
+    public static final int MASK_DIRECTION = 0b0000_0111;
     public RotatableBlock(String key, String namespaceId, int id, Material material) {
         super(key, namespaceId, id, material);
     }
@@ -20,33 +23,37 @@ public abstract class RotatableBlock extends Block{
         int idPosZ = world.getBlockId(x, y, z + 1);
         int idNegX = world.getBlockId(x - 1, y, z);
         int idPosX = world.getBlockId(x + 1, y, z);
-        byte byte0 = 3;
+        Direction direction = Direction.SOUTH;
         if(Block.solid[idNegZ] && !Block.solid[idPosZ])
         {
-            byte0 = 3;
+            direction = Direction.SOUTH;
         }
         if(Block.solid[idPosZ] && !Block.solid[idNegZ])
         {
-            byte0 = 2;
+            direction = Direction.NORTH;
         }
         if(Block.solid[idNegX] && !Block.solid[idPosX])
         {
-            byte0 = 5;
+            direction = Direction.EAST;
         }
         if(Block.solid[idPosX] && !Block.solid[idNegX])
         {
-            byte0 = 4;
+            direction = Direction.WEST;
         }
-        world.setBlockMetadataWithNotify(x, y, z, byte0);
+        world.setBlockMetadataWithNotify(x, y, z, setDirection(0, direction));
     }
 
-    public static int getOrientation(int i)
+    public static Direction getDirectionFromMeta(int meta)
     {
-        return i & 7;
+        return Direction.getDirectionById(meta & MASK_DIRECTION);
+    }
+
+    public static int setDirection(int meta, Direction direction) {
+        return (meta & ~MASK_DIRECTION) | direction.getId();
     }
 
     @Override
-    public void onBlockPlacedByMob(World world, int x, int y, int z, Side side, Mob mob, double sideHeight) {
+    public void onBlockPlacedByMob(World world, int x, int y, int z, @NotNull Side side, Mob mob, double sideHeight) {
         world.setBlockMetadataWithNotify(x, y, z, mob.getHorizontalPlacementDirection(side).getOpposite().getId());
     }
 
diff --git a/src/main/java/net/minecraft/core/block/RotatableEntityBlock.java b/src/main/java/net/minecraft/core/block/RotatableEntityBlock.java
index f8523a78e..21a7614f1 100644
--- a/src/main/java/net/minecraft/core/block/RotatableEntityBlock.java
+++ b/src/main/java/net/minecraft/core/block/RotatableEntityBlock.java
@@ -2,46 +2,48 @@ package net.minecraft.core.block;
 
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.entity.Mob;
+import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
+import org.jetbrains.annotations.NotNull;
 
 public abstract class RotatableEntityBlock extends EntityBlock {
 
 	public RotatableEntityBlock(String key, String namespaceId, int id, Material material) {
         super(key, namespaceId, id, material);
     }
-	public void setDefaultDirection(World world, int i, int j, int k)
+	public void setDefaultDirection(World world, int x, int y, int z)
     {
         if(world.isClientSide)
         {
             return;
         }
-        int l = world.getBlockId(i, j, k - 1);
-        int i1 = world.getBlockId(i, j, k + 1);
-        int j1 = world.getBlockId(i - 1, j, k);
-        int k1 = world.getBlockId(i + 1, j, k);
-        byte byte0 = 3;
-        if(Block.solid[l] && !Block.solid[i1])
+        int idNegZ = world.getBlockId(x, y, z - 1);
+        int idPosZ = world.getBlockId(x, y, z + 1);
+        int idNegX = world.getBlockId(x - 1, y, z);
+        int idPosX = world.getBlockId(x + 1, y, z);
+        Direction direction = Direction.SOUTH;
+        if(Block.solid[idNegZ] && !Block.solid[idPosZ])
         {
-            byte0 = 3;
+            direction = Direction.SOUTH;
         }
-        if(Block.solid[i1] && !Block.solid[l])
+        if(Block.solid[idPosZ] && !Block.solid[idNegZ])
         {
-            byte0 = 2;
+            direction = Direction.NORTH;
         }
-        if(Block.solid[j1] && !Block.solid[k1])
+        if(Block.solid[idNegX] && !Block.solid[idPosX])
         {
-            byte0 = 5;
+            direction = Direction.EAST;
         }
-        if(Block.solid[k1] && !Block.solid[j1])
+        if(Block.solid[idPosX] && !Block.solid[idNegX])
         {
-            byte0 = 4;
+            direction = Direction.WEST;
         }
-        world.setBlockMetadataWithNotify(i, j, k, byte0);
+        world.setBlockMetadataWithNotify(x, y, z, RotatableBlock.setDirection(0, direction));
     }
 
     @Override
-    public void onBlockPlacedByMob(World world, int x, int y, int z, Side side, Mob mob, double sideHeight) {
+    public void onBlockPlacedByMob(World world, int x, int y, int z, @NotNull Side side, Mob mob, double sideHeight) {
     	world.setBlockMetadataWithNotify(x, y, z, mob.getHorizontalPlacementDirection(side).getOpposite().getId());
     }
 
